"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    List,
    Optional,
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class StaticPermission(DevopnessBaseModel):
    """
    StaticPermission

    Attributes:
        name (str): Name of permission
        human_readable (str): Human readable permission name
        hint (str): Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field
        required_permissions (List[str], optional): List of permissions the role must have before receiving this one
    """

    name: StrictStr = Field(description="Name of permission")
    human_readable: StrictStr = Field(description="Human readable permission name")
    hint: StrictStr = Field(
        description="Descriptive text to help users to know what data is stored in the field and optional extra information on how to enter data to the field"
    )
    required_permissions: Optional[List[StrictStr]] = Field(
        default=None,
        description="List of permissions the role must have before receiving this one",
    )


class StaticPermissionPlain(TypedDict, total=False):
    """
    Plain version of StaticPermission.
    """

    name: Required[str]
    human_readable: Required[str]
    hint: Required[str]
    required_permissions: Optional[List[str]]
